package jkje.swing;

/**
 * Title:        workcover submission
 * Description:
 * Copyright:    Copyright (c) 2005
 * Company:      jkje pty ltd
 * @author John Kwok
 * @version 1.0
 */
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.lang.*;

public class TipRenderer extends DefaultTableCellRenderer{

  public TipRenderer() {
  }

  public Component getTableCellRendererComponent (JTable table, Object value,
                                          boolean isSelected, boolean isFocused,
                                          int row, int column) {
    Component component=super.getTableCellRendererComponent(table, value, isSelected, isFocused,
                                                            row, column);
    //System.out.println("fontsize="+component.getFont().getSize());
    //System.out.println("isFocused="+isFocused);
    //if (isFocused) {
      if (value instanceof String) {
        String s=(String)value;
       // System.out.println("s len="+s.length()+" s="+s);
        TableColumnModel tcm = table.getColumnModel();
        TableColumn col = tcm.getColumn(column);

        int colWidth=col.getWidth();
        //int lblWidth=s.length()*6;
        //System.out.println("s len="+s.length()+" s="+s+" font size="+table.getFont().getSize());
        int lblWidth=s.trim().length()*table.getFont().getSize();

        //System.out.println("min col with="+col.getMinWidth() +" column width="+colWidth+" label width="+lblWidth);
        if ( lblWidth > colWidth) {
          ((JLabel)component).setToolTipText((String)(table.getValueAt(row,column)) );
            //System.out.println("string len " + s.length());
            //System.out.println("font size " + (JTable1.getFont()).getSize());

          col.setMinWidth(Math.max(col.getMinWidth(),lblWidth));
          //if (isSelected) {
            //table.getTableHeader().getTable().getColumnModel().getColumn(column).setWidth(lblWidth);
            //col.setWidth(lblWidth);
            //table.revalidate();
          //}
        } else ((JLabel)component).setToolTipText(null);

      }
    //}
    return component;
  }

}